diff --git a/tests/test_hub/test_list_btypes.py b/tests/test_hub/test_list_btypes.py
index 82907ac..78343e0 100644
--- a/tests/test_hub/test_list_btypes.py
+++ b/tests/test_hub/test_list_btypes.py
@@ -8,64 +8,58 @@ QP = kojihub.QueryProcessor
 
 class TestListBTypes(unittest.TestCase):
 
-    @mock.patch('kojihub.QueryProcessor')
-    def test_list_btypes(self, QueryProcessor):
+    def setUp(self):
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.get_query).start()
+        self.queries = []
+        self.exports = kojihub.RootExports()
 
-        # default query
-        query = QueryProcessor.return_value
-        query.execute.return_value = "return value"
-        ret = kojihub.list_btypes()
-        QueryProcessor.assert_called_once()
-        query.execute.assert_called_once()
-        self.assertEqual(ret, "return value")
+    def tearDown(self):
+        mock.patch.stopall()
 
-        args, kwargs = QueryProcessor.call_args
-        self.assertEqual(args, ())
-        qp = QP(**kwargs)
-        self.assertEqual(qp.tables, ['btype'])
-        self.assertEqual(qp.columns, ['id', 'name'])
-        self.assertEqual(qp.clauses, [])
-        self.assertEqual(qp.joins, None)
-
-        QueryProcessor.reset_mock()
+    def get_query(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
 
-        # query by name
-        query = QueryProcessor.return_value
-        query.execute.return_value = "return value"
-        ret = kojihub.list_btypes({'name': 'rpm'})
-        QueryProcessor.assert_called_once()
-        query.execute.assert_called_once()
-        self.assertEqual(ret, "return value")
+    def test_list_btypes_default(self):
+        kojihub.list_btypes()
+        self.QueryProcessor.assert_called_once()
 
-        args, kwargs = QueryProcessor.call_args
+        args, kwargs = self.QueryProcessor.call_args
         self.assertEqual(args, ())
-        qp = QP(**kwargs)
-        self.assertEqual(qp.tables, ['btype'])
-        self.assertEqual(qp.columns, ['id', 'name'])
-        self.assertEqual(qp.clauses, ['btype.name = %(name)s'])
-        self.assertEqual(qp.values, {'name': 'rpm'})
-        self.assertEqual(qp.joins, None)
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['btype'])
+        self.assertEqual(query.columns, ['id', 'name'])
+        self.assertEqual(query.clauses, [])
+        self.assertEqual(query.joins, None)
 
-        QueryProcessor.reset_mock()
+    def test_list_btypes_by_name(self):
+        kojihub.list_btypes({'name': 'rpm'})
+        self.QueryProcessor.assert_called_once()
 
-        # query by id, with opts
-        query = QueryProcessor.return_value
-        query.execute.return_value = "return value"
-        ret = kojihub.list_btypes({'id': 1}, {'order': 'id'})
-        QueryProcessor.assert_called_once()
-        query.execute.assert_called_once()
-        self.assertEqual(ret, "return value")
-
-        args, kwargs = QueryProcessor.call_args
+        args, kwargs = self.QueryProcessor.call_args
         self.assertEqual(args, ())
-        qp = QP(**kwargs)
-        self.assertEqual(qp.tables, ['btype'])
-        self.assertEqual(qp.columns, ['id', 'name'])
-        self.assertEqual(qp.clauses, ['btype.id = %(id)s'])
-        self.assertEqual(qp.values, {'id': 1})
-        self.assertEqual(qp.opts, {'order': 'id'})
-        self.assertEqual(qp.joins, None)
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['btype'])
+        self.assertEqual(query.columns, ['id', 'name'])
+        self.assertEqual(query.clauses, ['btype.name = %(name)s'])
+        self.assertEqual(query.values, {'name': 'rpm'})
+        self.assertEqual(query.joins, None)
 
-        QueryProcessor.reset_mock()
+    def test_list_btypes_by_it_with_opts(self):
+        kojihub.list_btypes({'id': 1}, {'order': 'id'})
+        self.QueryProcessor.assert_called_once()
 
-        # query by name
+        args, kwargs = self.QueryProcessor.call_args
+        self.assertEqual(args, ())
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['btype'])
+        self.assertEqual(query.columns, ['id', 'name'])
+        self.assertEqual(query.clauses, ['btype.id = %(id)s'])
+        self.assertEqual(query.values, {'id': 1})
+        self.assertEqual(query.opts, {'order': 'id'})
+        self.assertEqual(query.joins, None)
diff --git a/tests/test_hub/test_list_builds.py b/tests/test_hub/test_list_builds.py
index 361fd29..5e172f4 100644
--- a/tests/test_hub/test_list_builds.py
+++ b/tests/test_hub/test_list_builds.py
@@ -25,6 +25,8 @@ class TestListBuilds(unittest.TestCase):
         self.queries = []
 
         self.context = mock.patch('kojihub.context').start()
+        self.get_package_id = mock.patch('kojihub.get_package_id').start()
+        self.get_user = mock.patch('kojihub.get_user').start()
         self.cursor = mock.MagicMock()
         self.build_list = [{'build_id': 9,
                             'epoch': 0,
@@ -41,18 +43,16 @@ class TestListBuilds(unittest.TestCase):
                             'volume_id': 0,
                             'volume_name': 'DEFAULT'}]
 
-    @mock.patch('kojihub.get_package_id')
-    def test_wrong_package(self, get_package_id):
+    def test_wrong_package(self):
         package = 'test-package'
-        get_package_id.return_value = None
+        self.get_package_id.return_value = None
         rv = self.exports.listBuilds(packageID=package)
         self.assertEqual(rv, [])
 
-    @mock.patch('kojihub.get_package_id')
-    def test_package_string(self, get_package_id):
+    def test_package_string(self):
         package = 'test-package'
         package_id = 1
-        get_package_id.return_value = package_id
+        self.get_package_id.return_value = package_id
         self.query_executeOne.return_value = None
         self.exports.listBuilds(packageID=package)
         self.assertEqual(len(self.queries), 1)
@@ -76,9 +76,8 @@ class TestListBuilds(unittest.TestCase):
                                     'LEFT JOIN volume ON build.volume_id = volume.id',
                                     'LEFT JOIN users ON build.owner = users.id'])
 
-    @mock.patch('kojihub.get_user')
-    def test_wrong_user(self, get_user):
+    def test_wrong_user(self):
         user = 'test-user'
-        get_user.return_value = None
+        self.get_user.return_value = None
         rv = self.exports.listBuilds(userID=user)
         self.assertEqual(rv, [])
diff --git a/tests/test_hub/test_list_packages_simple.py b/tests/test_hub/test_list_packages_simple.py
new file mode 100644
index 0000000..47cf772
--- /dev/null
+++ b/tests/test_hub/test_list_packages_simple.py
@@ -0,0 +1,40 @@
+import unittest
+import kojihub
+import mock
+
+QP = kojihub.QueryProcessor
+
+
+class TestListPackagesSimple(unittest.TestCase):
+
+    def setUp(self):
+        self.maxDiff = None
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.get_query).start()
+        self.queries = []
+        self.exports = kojihub.RootExports()
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def get_query(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def test_prefix_not_none(self):
+        self.exports.listPackagesSimple('test-prefix')
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['package'])
+        self.assertEqual(query.clauses, ["package.name ILIKE %(prefix)s || '%%'"])
+        self.assertEqual(query.joins, None)
+
+    def test_prefix_is_none(self):
+        self.exports.listPackagesSimple()
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['package'])
+        self.assertEqual(query.clauses, None)
+        self.assertEqual(query.joins, None)
diff --git a/tests/test_hub/test_list_rpms.py b/tests/test_hub/test_list_rpms.py
index 88449dd..e0d0669 100644
--- a/tests/test_hub/test_list_rpms.py
+++ b/tests/test_hub/test_list_rpms.py
@@ -1,14 +1,87 @@
 import unittest
+import mock
 
 import koji
 import kojihub
 
+QP = kojihub.QueryProcessor
+
 
 class TestListRpms(unittest.TestCase):
+    def setUp(self):
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.get_query).start()
+        self.queries = []
+        self.get_build = mock.patch('kojihub.get_build').start()
+        self.get_host = mock.patch('kojihub.get_host').start()
+        self._dml = mock.patch('kojihub._dml').start()
+        self.list_rpms = {'arch': 'x86_64',
+                          'build_id': 1,
+                          'buildroot_id': 2,
+                          'buildtime': 1596090711,
+                          'epoch': 2,
+                          'external_repo_id': 1,
+                          'external_repo_name': 'fedora-34-released',
+                          'extra': None,
+                          'id': 277,
+                          'metadata_only': False,
+                          'name': 'shadow-utils',
+                          'nvr': 'shadow-utils-4.8.1-4.fc33',
+                          'payloadhash': 'c5bfe5267dc6e0ca127092a82b4f260b',
+                          'release': '4.fc33',
+                          'size': 3891272,
+                          'version': '4.8.1'}
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def get_query(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
 
     def test_wrong_type_arches(self):
         arches = {'test-arch': 'val'}
         with self.assertRaises(koji.GenericError) as cm:
             kojihub.list_rpms(arches=arches)
-        self.assertEqual('Invalid type for "arches" parameter: %s' % type(arches),
-                         str(cm.exception))
+        self.assertEqual(f'Invalid type for "arches" parameter: {type(arches)}', str(cm.exception))
+
+    def test_int_values(self):
+        build_id = 1
+        buildroot_id = 1
+        host_id = 1
+        arches = 'x86_64'
+        kojihub.list_rpms(arches=arches, buildID=build_id, buildrootID=buildroot_id,
+                          hostID=host_id)
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['rpminfo'])
+        self.assertEqual(query.joins,
+                         ['LEFT JOIN external_repo ON rpminfo.external_repo_id = external_repo.id',
+                          'standard_buildroot ON rpminfo.buildroot_id = '
+                          'standard_buildroot.buildroot_id'])
+        self.assertEqual(query.clauses, [
+            'rpminfo.arch = %(arches)s',
+            'rpminfo.build_id = %(buildID)i',
+            'rpminfo.buildroot_id = %(buildrootID)i',
+            'standard_buildroot.host_id = %(hostID)i',
+        ])
+
+    def test_compoenent_buldroot_image_list_arch_values(self):
+        comp_buildroot_id = 1
+        image_id = 1
+        arches = ['x86_64']
+        kojihub.list_rpms(componentBuildrootID=comp_buildroot_id, imageID=image_id, arches=arches)
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        self.assertEqual(query.tables, ['rpminfo'])
+        self.assertEqual(query.joins,
+                         ['LEFT JOIN external_repo ON rpminfo.external_repo_id = external_repo.id',
+                          'buildroot_listing ON rpminfo.id = buildroot_listing.rpm_id',
+                          'archive_rpm_components ON rpminfo.id = archive_rpm_components.rpm_id'])
+        self.assertEqual(query.clauses, [
+            'archive_rpm_components.archive_id = %(imageID)i',
+            'buildroot_listing.buildroot_id = %(componentBuildrootID)i',
+            'rpminfo.arch IN %(arches)s',
+        ])
diff --git a/tests/test_hub/test_list_tasks.py b/tests/test_hub/test_list_tasks.py
new file mode 100644
index 0000000..95cf850
--- /dev/null
+++ b/tests/test_hub/test_list_tasks.py
@@ -0,0 +1,78 @@
+import mock
+import unittest
+
+import kojihub
+
+
+class TestListing(unittest.TestCase):
+    def setUp(self):
+        self.hub = kojihub.RootExports()
+        self.standard_processor_kwargs = dict(
+            tables=mock.ANY,
+            columns=mock.ANY,
+            values=mock.ANY,
+            joins=mock.ANY,
+            clauses=mock.ANY,
+            opts=mock.ANY,
+            aliases=mock.ANY,
+        )
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_basic_invocation(self, processor):
+        generator = self.hub.listTasks()
+        list(generator)  # Exhaust the generator
+        processor.assert_called_once_with(**self.standard_processor_kwargs)
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_owner_as_int(self, processor):
+        generator = self.hub.listTasks(opts={'owner': 1})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['owner = %(owner)i']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_not_owner_as_int(self, processor):
+        generator = self.hub.listTasks(opts={'not_owner': 1})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['owner != %(not_owner)i']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_arch(self, processor):
+        generator = self.hub.listTasks(opts={'arch': ['x86_64']})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['arch IN %(arch)s']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_not_arch(self, processor):
+        generator = self.hub.listTasks(opts={'not_arch': ['x86_64']})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['arch NOT IN %(not_arch)s']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_owner_as_list(self, processor):
+        generator = self.hub.listTasks(opts={'owner': [1, 2]})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['owner IN %(owner)s']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
+
+    @mock.patch('kojihub.QueryProcessor')
+    def test_list_tasks_by_not_owner_as_list(self, processor):
+        generator = self.hub.listTasks(opts={'not_owner': [1, 2]})
+        results = list(generator)  # Exhaust the generator
+        arguments = self.standard_processor_kwargs.copy()
+        arguments['clauses'] = ['owner NOT IN %(not_owner)s']
+        processor.assert_called_once_with(**arguments)
+        self.assertEqual(results, [])
diff --git a/tests/test_hub/test_lookup_name.py b/tests/test_hub/test_lookup_name.py
index 42346fa..39c9ca6 100644
--- a/tests/test_hub/test_lookup_name.py
+++ b/tests/test_hub/test_lookup_name.py
@@ -44,12 +44,11 @@ class TestLookupName(unittest.TestCase):
             {'id': 'not a valid int'},
             ['something'],
             set(),
-            ]
+        ]
         for value in bad_values:
             with self.assertRaises(koji.GenericError) as cm:
                 kojihub.lookup_name('mytable', value)
-            self.assertEqual('Invalid name or id value: %s' % value,
-                             str(cm.exception))
+            self.assertEqual(f'Invalid name or id value: {value}', str(cm.exception))
         self.assertEqual(len(self.queries), 0)
         self.assertEqual(len(self.inserts), 0)
 
@@ -78,7 +77,7 @@ class TestLookupName(unittest.TestCase):
         self.assertEqual(len(self.inserts), 0)
 
     def test_query_by_dict(self):
-        kojihub.lookup_name('some_table', {'id':12345, 'name': 'whatever'})
+        kojihub.lookup_name('some_table', {'id': 12345, 'name': 'whatever'})
         self.assertEqual(len(self.queries), 1)
         query = self.queries[0]
         clauses = ['(some_table.id = %(some_table_id)s)']
@@ -110,7 +109,7 @@ class TestLookupName(unittest.TestCase):
 
     def test_lookup_name_strict(self):
         self.query_executeOne.return_value = None
-        with self.assertRaises(koji.GenericError) as cm:
+        with self.assertRaises(koji.GenericError):
             kojihub.lookup_name('package', 'python', strict=True)
         self.assertEqual(len(self.queries), 1)
         self.assertEqual(len(self.inserts), 0)
@@ -134,7 +133,7 @@ class TestLookupName(unittest.TestCase):
         bad_values = [
             {'id': 100},
             100
-            ]
+        ]
         for value in bad_values:
             with self.assertRaises(koji.GenericError) as cm:
                 kojihub.lookup_name('package', value, create=True)
diff --git a/tests/test_hub/test_maven_build.py b/tests/test_hub/test_maven_build.py
new file mode 100644
index 0000000..90a4d4c
--- /dev/null
+++ b/tests/test_hub/test_maven_build.py
@@ -0,0 +1,49 @@
+import unittest
+import koji
+import kojihub
+import mock
+
+
+class TestMaven(unittest.TestCase):
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.exports = kojihub.RootExports()
+        self.context.session.assertLogin = mock.MagicMock()
+        self.context.session.hasPerm = mock.MagicMock()
+        self.get_channel = mock.patch('kojihub.get_channel').start()
+        self.make_task = mock.patch('kojihub.make_task').start()
+        self.url = 'https://test-url.com'
+        self.target = 'test-target'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_maven_not_supported(self):
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.mavenBuild(self.url, self.target)
+        self.assertEqual("Maven support not enabled", str(cm.exception))
+
+    def test_url_not_str(self):
+        url = ['test-url']
+        self.context.opts.get.return_value = True
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.mavenBuild(url, self.target)
+        self.assertEqual(f"Invalid type for value '{url}': {type(url)}", str(cm.exception))
+
+    def test_priority_without_admin(self):
+        priority = -10
+        self.context.opts.get.return_value = True
+        self.context.session.hasPerm.return_value = False
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.mavenBuild(self.url, self.target, priority=priority)
+        self.assertEqual("only admins may create high-priority tasks", str(cm.exception))
+
+    def test_channel_not_str(self):
+        priority = 10
+        self.context.opts.get.return_value = True
+        self.get_channel.return_value = {'comment': None, 'description': None, 'enabled': True,
+                                         'id': 2, 'name': 'maven'}
+        self.make_task.return_value = 123
+        self.exports.mavenBuild(self.url, self.target, priority=priority, channel=2)
diff --git a/tests/test_hub/test_new_build.py b/tests/test_hub/test_new_build.py
index fef494b..284f973 100644
--- a/tests/test_hub/test_new_build.py
+++ b/tests/test_hub/test_new_build.py
@@ -6,6 +6,7 @@ import kojihub
 
 IP = kojihub.InsertProcessor
 
+
 class TestNewBuild(unittest.TestCase):
     def setUp(self):
         self.get_rpm = mock.patch('kojihub.get_rpm').start()
@@ -13,7 +14,7 @@ class TestNewBuild(unittest.TestCase):
         self.nextval = mock.patch('kojihub.nextval').start()
         self.Savepoint = mock.patch('kojihub.Savepoint').start()
         self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
-                side_effect=self.getInsert).start()
+                                          side_effect=self.getInsert).start()
         self.inserts = []
         self.insert_execute = mock.MagicMock()
         self.lookup_package = mock.patch('kojihub.lookup_package').start()
@@ -35,7 +36,7 @@ class TestNewBuild(unittest.TestCase):
 
     def test_valid(self):
         self.get_build.return_value = None
-        self._singleValue.return_value = 65 # free build id
+        self._singleValue.return_value = 65  # free build id
         self.new_package.return_value = 54
         self.get_user.return_value = {'id': 123}
         data = {
@@ -99,10 +100,11 @@ class TestNewBuild(unittest.TestCase):
             'extra': {'extra_key': 'extra_value'},
         }
 
-        with self.assertRaises(koji.GenericError):
+        with self.assertRaises(koji.GenericError) as cm:
             kojihub.new_build(data)
 
         self.assertEqual(len(self.inserts), 0)
+        self.assertEqual("No name or package id provided for build", str(cm.exception))
 
     def test_wrong_owner(self):
         self.get_user.side_effect = koji.GenericError
@@ -121,7 +123,6 @@ class TestNewBuild(unittest.TestCase):
         self.assertEqual(len(self.inserts), 0)
 
     def test_missing_vre(self):
-        self.get_user.side_effect = koji.GenericError
         data = {
             'name': 'test_name',
             'version': 'test_version',
diff --git a/tests/test_hub/test_repo_delete.py b/tests/test_hub/test_repo_delete.py
new file mode 100644
index 0000000..fe87fbb
--- /dev/null
+++ b/tests/test_hub/test_repo_delete.py
@@ -0,0 +1,13 @@
+import unittest
+
+import koji
+import kojihub
+
+
+class TestRepoDelete(unittest.TestCase):
+
+    def test_repo_delete_wrong_type_typeID(self):
+        repo_id = 'test-repo-id'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.repo_delete(repo_id)
+        self.assertEqual(f"Invalid type for value '{repo_id}': {type(repo_id)}", str(cm.exception))
diff --git a/tests/test_hub/test_repo_init.py b/tests/test_hub/test_repo_init.py
new file mode 100644
index 0000000..b3c30c8
--- /dev/null
+++ b/tests/test_hub/test_repo_init.py
@@ -0,0 +1,13 @@
+import unittest
+
+import koji
+import kojihub
+
+
+class TestRepoInit(unittest.TestCase):
+
+    def test_repo_init_wrong_type_typeID(self):
+        task_id = 'test-task_id'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.repo_init('test-tag', task_id)
+        self.assertEqual(f"Invalid type for value '{task_id}': {type(task_id)}", str(cm.exception))
diff --git a/tests/test_hub/test_repo_set_state.py b/tests/test_hub/test_repo_set_state.py
new file mode 100644
index 0000000..b6a5007
--- /dev/null
+++ b/tests/test_hub/test_repo_set_state.py
@@ -0,0 +1,13 @@
+import unittest
+
+import koji
+import kojihub
+
+
+class TestRepoSetState(unittest.TestCase):
+
+    def test_set_state_wrong_type_typeID(self):
+        repo_id = 'test-repo-id'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.repo_set_state(repo_id, 'failed')
+        self.assertEqual(f"Invalid type for value '{repo_id}': {type(repo_id)}", str(cm.exception))
diff --git a/tests/test_hub/test_repos.py b/tests/test_hub/test_repos.py
index 48c7cd7..19d14ca 100644
--- a/tests/test_hub/test_repos.py
+++ b/tests/test_hub/test_repos.py
@@ -26,6 +26,7 @@ class TestRepoFunctions(unittest.TestCase):
         self.updates = []
         self._dml = mock.patch('kojihub._dml').start()
         self.exports = kojihub.RootExports()
+        self.get_tag = mock.patch('kojihub.get_tag').start()
 
     def tearDown(self):
         mock.patch.stopall()
@@ -83,7 +84,8 @@ class TestRepoFunctions(unittest.TestCase):
                     'state': 0,
                     'task_id': 15,
                     'create_event': 32,
-                    'creation_time': datetime.datetime(2021, 3, 30, 12, 34, 5, 204023, tzinfo=datetime.timezone.utc),
+                    'creation_time': datetime.datetime(2021, 3, 30, 12, 34, 5, 204023,
+                                                       tzinfo=datetime.timezone.utc),
                     'create_ts': 1617107645.204023,
                     'tag_id': 3,
                     'tag_name': 'test-tag',
@@ -92,8 +94,8 @@ class TestRepoFunctions(unittest.TestCase):
         rv = kojihub.repo_info(3)
         self.assertEqual(rv, repo_row)
 
-    def test_get_repo(self):
-        rv = self.exports.getRepo(2)
+    def test_get_repo_default(self):
+        self.exports.getRepo(2)
         self.assertEqual(len(self.queries), 1)
         query = self.queries[0]
         # make sure the following does not error
@@ -105,3 +107,17 @@ class TestRepoFunctions(unittest.TestCase):
         self.assertEqual(query.joins, ['events ON repo.create_event = events.id'])
         self.assertEqual(query.clauses, ['repo.dist is false', 'repo.state = %(state)s',
                                          'repo.tag_id = %(id)i'])
+
+    def test_get_repo_with_dist_and_event(self):
+        self.exports.getRepo(2, event=111, dist=True)
+        self.assertEqual(len(self.queries), 1)
+        query = self.queries[0]
+        # make sure the following does not error
+        str(query)
+        self.assertEqual(query.tables, ['repo'])
+        columns = ['repo.id', 'repo.state', 'repo.task_id', 'repo.create_event',
+                   'EXTRACT(EPOCH FROM events.time)', 'repo.dist', 'events.time']
+        self.assertEqual(set(query.columns), set(columns))
+        self.assertEqual(query.joins, ['events ON repo.create_event = events.id'])
+        self.assertEqual(query.clauses, ['create_event <= %(event)i', 'repo.dist is true',
+                                         'repo.tag_id = %(id)i'])
diff --git a/tests/test_hub/test_restart_hosts.py b/tests/test_hub/test_restart_hosts.py
index 5da1c32..4bd6fc3 100644
--- a/tests/test_hub/test_restart_hosts.py
+++ b/tests/test_hub/test_restart_hosts.py
@@ -2,6 +2,7 @@ import unittest
 
 import mock
 
+import koji
 import kojihub
 
 
@@ -13,12 +14,18 @@ class TestRestartHosts(unittest.TestCase):
         self.context.session.assertPerm = mock.MagicMock()
         self.make_task = mock.patch('kojihub.make_task').start()
 
-    def options_is_none(self):
+    def test_options_is_none(self):
         self.make_task.return_value = 13
         rv = self.exports.restartHosts()
         self.assertEqual(rv, 13)
 
-    def options_is_not_none(self):
+    def test_options_is_not_none(self):
         self.make_task.return_value = 13
         rv = self.exports.restartHosts(options={'opt': 'open'})
         self.assertEqual(rv, 13)
+
+    def test_options_wrong_type(self):
+        options = 'test-options'
+        with self.assertRaises(koji.ParameterError) as ex:
+            self.exports.restartHosts(options=options)
+        self.assertEqual(f"Invalid type of options: {type(options)}", str(ex.exception))
diff --git a/tests/test_hub/test_search.py b/tests/test_hub/test_search.py
index 72fb162..1f8ecff 100644
--- a/tests/test_hub/test_search.py
+++ b/tests/test_hub/test_search.py
@@ -18,4 +18,4 @@ class TestSearch(unittest.TestCase):
         type = 'test-type'
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.search('item', type, 'glob')
-        self.assertEqual("No such search type: %s" % type, str(cm.exception))
+        self.assertEqual(f"No such search type: {type}", str(cm.exception))
diff --git a/tests/test_hub/test_tag_operations.py b/tests/test_hub/test_tag_operations.py
index d15de00..381b78c 100644
--- a/tests/test_hub/test_tag_operations.py
+++ b/tests/test_hub/test_tag_operations.py
@@ -252,16 +252,22 @@ class TestGetTag(unittest.TestCase):
         self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
                                          side_effect=self.getQuery).start()
         self.queries = []
+        self.tagname = 'test-tag'
 
     def test_get_tag_invalid_taginfo(self):
         taginfo = {'test-tag': 'value'}
         with self.assertRaises(koji.GenericError) as ex:
             kojihub.get_tag(taginfo, strict=True)
-        self.assertEqual("Invalid name or id value: %s" % taginfo, str(ex.exception))
+        self.assertEqual(f"Invalid name or id value: {taginfo}", str(ex.exception))
 
     def test_get_tag_non_exist_tag(self):
-        taginfo = 'test-tag'
         self.query_executeOne.return_value = None
         with self.assertRaises(koji.GenericError) as ex:
-            kojihub.get_tag(taginfo, strict=True)
-        self.assertEqual("No such tagInfo: '%s'" % taginfo, str(ex.exception))
+            kojihub.get_tag(self.tagname, strict=True)
+        self.assertEqual(f"No such tagInfo: '{self.tagname}'", str(ex.exception))
+
+    def test_get_tag_wrong_event(self):
+        event = 'unsupported-event'
+        with self.assertRaises(koji.GenericError) as ex:
+            kojihub.get_tag(self.tagname, event=event)
+        self.assertEqual(f"Invalid event: '{event}'", str(ex.exception))
